#!/usr/bin/env Rscript  
#########################################################
# TASK: Script to format data for dm om plots: 
# generating WF LF data
# sourced by get_plotting_dfs.R
# calls my function: dm_om_wf_lf_data()
#########################################################
  geneL_normal  = c("pnca")
  geneL_na_dy   = c("gid")
  geneL_na      = c("gid", "rpob")
  geneL_dy      = c("gid")
  geneL_ppi2    = c("alr", "embb", "katg", "rpob")
  
all_dm_om_df = dm_om_wf_lf_data(df = merged_df3, gene_name = gene)

wf_duet      = all_dm_om_df[['wf_duet']]
lf_duet      = all_dm_om_df[['lf_duet']]

wf_mcsm_lig  = all_dm_om_df[['wf_mcsm_lig']]
lf_mcsm_lig  = all_dm_om_df[['lf_mcsm_lig']]

wf_foldx     = all_dm_om_df[['wf_foldx']]
lf_foldx     = all_dm_om_df[['lf_foldx']]

wf_deepddg   = all_dm_om_df[['wf_deepddg']]
lf_deepddg   = all_dm_om_df[['lf_deepddg']]

wf_dynamut2  = all_dm_om_df[['wf_dynamut2']]
lf_dynamut2  = all_dm_om_df[['lf_dynamut2']]

wf_consurf   = all_dm_om_df[['wf_consurf']]
lf_consurf   = all_dm_om_df[['lf_consurf']]

wf_snap2     = all_dm_om_df[['wf_snap2']]
lf_snap2     = all_dm_om_df[['lf_snap2']]

if (tolower(gene)%in%geneL_na){
wf_mcsm_na   = all_dm_om_df[['wf_mcsm_na']]
lf_mcsm_na   = all_dm_om_df[['lf_mcsm_na']]
}

if (tolower(gene)%in%geneL_ppi2){
wf_mcsm_ppi2 = all_dm_om_df[['wf_mcsm_ppi2']]
lf_mcsm_ppi2 = all_dm_om_df[['lf_mcsm_ppi2']]
}

if (tolower(gene)%in%geneL_dy){
wf_dynamut   = all_dm_om_df[['wf_dynamut']]
lf_dynamut   = all_dm_om_df[['lf_dynamut']]

wf_encomddg  = all_dm_om_df[['wf_encomddg']]
lf_encomddg  = all_dm_om_df[['lf_encomddg']]

wf_encomdds  = all_dm_om_df[['wf_encomdds']]
lf_encomdds  = all_dm_om_df[['lf_encomdds']]

wf_sdm       = all_dm_om_df[['wf_sdm']]
lf_sdm       = all_dm_om_df[['lf_sdm']]

wf_mcsm      = all_dm_om_df[['wf_mcsm']]
lf_mcsm      = all_dm_om_df[['lf_mcsm']]
}
